// SETA43
// http://www.seta43.netau.net/electro.html
// 15-03-2013


#include <LiquidCrystal.h>

#define DDS_CLOCK 125000000

#define  CLOCK  8  //pin connections for DDS
#define  LOAD 9 
#define  DATA  10
#define  RESET 11

#define e1Pin 14
#define e2Pin 15

char buffer[30];

long e[8];
int z;

 long frecuencia,frecu;
 long multi;
 int mymenu;
 long sensor,oldsensor;

 LiquidCrystal lcd(2,3,4,5,6,7);
 void setup()
 {      
  Serial.begin(9600);
  lcd.begin(16, 2);
  
  pinMode (e1Pin,INPUT);
  pinMode (e2Pin,INPUT);  
  
  pinMode (DATA,  OUTPUT); 
  pinMode (CLOCK, OUTPUT); 
  pinMode (LOAD,  OUTPUT); 
  pinMode (RESET, OUTPUT); 
  AD9850_init();
  AD9850_reset();
  
  frecuencia=20000;
  for(z=0;z<8;z++)e[z]=0;           
  e[4]=1;
  mymenu=0;
  sensor=0;
  
  lcd.setCursor(0,0);
  lcd.print("SETA43");
  delay(500);
  lcd.setCursor(0,1);
  lcd.print("xsetaseta@gmail");
  delay(2000);
  lcd.clear();
  
  printfrecu();
  SetFrequency(frecuencia);
  
  lcd.setCursor(0,0);
  lcd.print("AD9850");
 }
 
 void loop()
{  
  if(!digitalRead(e1Pin))
        {
         mymenu++;         
         if(mymenu>4)mymenu=0;
         while(!digitalRead(e1Pin));         
        }
  
  switch(mymenu)
    {      
      case 0:
       lcd.setCursor(7,0);
       lcd.print("     "); 
       if(sensor!=0)
         {
          sensor=0;
          printfrecu();
          SetFrequency(frecuencia);
         }  
       if(!digitalRead(e2Pin))
        {
         lcd.cursor();
         lcd.blink();
         lcd.setCursor(7,0);
         lcd.print("AJUSTE");
         for(z=0;z<8;z++)
           {
            lcd.setCursor(z,1);
            delay(200);
            while(digitalRead(e2Pin))
               {            
                if(!digitalRead(e1Pin))
                    {
                      e[z]++;
                      if(e[z]>9)e[z]=0;
                      lcd.setCursor(z,1);
                      lcd.print(e[z]);
                      lcd.setCursor(z,1);
                      delay(300);
                    }    
               }         
           }
         lcd.setCursor(7,0);
  //       for(z=0;z<8;z++)lcd.print(e[z]);           
         lcd.print("      ");
         lcd.noCursor();
         lcd.noBlink();
         printfrecu();
         SetFrequency(frecuencia);
         delay(500);    
        }
       break;
        case 1:
         lcd.setCursor(7,0);
         lcd.print(" +500 ");
         sensor = analogRead(A5)/2;         
         if(sensor!=oldsensor)
           {
            printfrecu();
            SetFrequency(frecuencia); 
           }    
         oldsensor=sensor;
         delay(100);
       break;
       case 2:
         lcd.setCursor(7,0);
         lcd.print(" +5K ");
         sensor = analogRead(A5)/2;
         sensor*=10;
         if(sensor!=oldsensor)
           {
            printfrecu();
            SetFrequency(frecuencia); 
           }    
         oldsensor=sensor;
         delay(100);
       break;
       case 3:
         lcd.setCursor(7,0);
         lcd.print("+50K ");
         sensor = analogRead(A5)/2;
         sensor*=100;
         if(sensor!=oldsensor)
           {
            printfrecu();
            SetFrequency(frecuencia); 
           }
         oldsensor=sensor;
         delay(100);         
       break;
       case 4:
         lcd.setCursor(7,0);
         lcd.print("+500K ");
         sensor = analogRead(A5)/2;
         sensor*=1000;
         if(sensor!=oldsensor)
           {
            printfrecu();
            SetFrequency(frecuencia); 
           }  
         oldsensor=sensor;
         delay(100);         
       break;
    }
  

}

void printfrecu()
{
  frecuencia=sensor+e[7]+e[6]*10+e[5]*100+e[4]*1000+e[3]*10000+e[2]*100000+e[1]*1000000+e[0]*10000000;
  if(frecuencia>40000000)frecuencia=40000000;
  sprintf(buffer,"%08ld Hz",frecuencia);               
  lcd.setCursor(0,1); 
  lcd.print(buffer); 
}

//_________________________________________________
//http://webshed.org/wiki/AD9850_Arduino

void SetFrequency(unsigned long frequency)
{
  unsigned long tuning_word = (frequency * pow(2, 32)) / DDS_CLOCK;
  digitalWrite (LOAD, LOW); 

  shiftOut(DATA, CLOCK, LSBFIRST, tuning_word);
  shiftOut(DATA, CLOCK, LSBFIRST, tuning_word >> 8);
  shiftOut(DATA, CLOCK, LSBFIRST, tuning_word >> 16);
  shiftOut(DATA, CLOCK, LSBFIRST, tuning_word >> 24);
  shiftOut(DATA, CLOCK, LSBFIRST, 0x0);
  digitalWrite (LOAD, HIGH); 
}

void AD9850_init()
{

  digitalWrite(RESET, LOW);
  digitalWrite(CLOCK, LOW);
  digitalWrite(LOAD, LOW);
  digitalWrite(DATA, LOW);
}

void AD9850_reset()
{
  //reset sequence is:
  // CLOCK & LOAD = LOW
  //  Pulse RESET high for a few uS (use 5 uS here)
  //  Pulse CLOCK high for a few uS (use 5 uS here)
  //  Set DATA to ZERO and pulse LOAD for a few uS (use 5 uS here)

  // data sheet diagrams show only RESET and CLOCK being used to reset the device, but I see no output unless I also
  // toggle the LOAD line here.

  digitalWrite(CLOCK, LOW);
  digitalWrite(LOAD, LOW);

  digitalWrite(RESET, LOW);
  delay(5);
  digitalWrite(RESET, HIGH);  //pulse RESET
  delay(5);
  digitalWrite(RESET, LOW);
  delay(5);

  digitalWrite(CLOCK, LOW);
  delay(5);
  digitalWrite(CLOCK, HIGH);  //pulse CLOCK
  delay(5);
  digitalWrite(CLOCK, LOW);
  delay(5);
  digitalWrite(DATA, LOW);    //make sure DATA pin is LOW

    digitalWrite(LOAD, LOW);
  delay(5);
  digitalWrite(LOAD, HIGH);  //pulse LOAD
  delay(5);
  digitalWrite(LOAD, LOW);
  // Chip is RESET now
}


